org.apache.poi.poifs.crypt

## Enum HashAlgorithm

- java.lang.Object
- - java.lang.Enum<HashAlgorithm>
  - - org.apache.poi.poifs.crypt.HashAlgorithm

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<HashAlgorithm>

      public enum HashAlgorithm
      extends java.lang.Enum<HashAlgorithm>

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `md2`
    `md4`
    `md5`
    `none`
    `ripemd128`
    `ripemd160`
    `ripemd256`
    `sha1`
    `sha224`
    `sha256`
    `sha384`
    `sha512`
    `whirlpool`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `int` | `ecmaId` the id used for the BIFF encryption info header
    `java.lang.String` | `ecmaString` the id used for OOXML encryption info header
    `int` | `hashSize` the length of the digest byte array
    `java.lang.String` | `jceHmacId` the id used for the integrity algorithm in agile encryption
    `java.lang.String` | `jceId` the id used for initializing the JCE message digest
    `boolean` | `needsBouncyCastle` is bouncycastle necessary for calculating the digest
    `java.lang.String` | `rsaOid` ASN1 object identifier of the digest value in combination with the RSA cipher

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static HashAlgorithm` | `fromEcmaId(int ecmaId)`
    `static HashAlgorithm` | `fromEcmaId(java.lang.String ecmaString)`
    `static HashAlgorithm` | `fromString(java.lang.String string)`
    `static HashAlgorithm` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static HashAlgorithm[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### none

          public static final HashAlgorithm none

    - #### sha1

          public static final HashAlgorithm sha1

    - #### sha256

          public static final HashAlgorithm sha256

    - #### sha384

          public static final HashAlgorithm sha384

    - #### sha512

          public static final HashAlgorithm sha512

    - #### md5

          public static final HashAlgorithm md5

    - #### md2

          public static final HashAlgorithm md2

    - #### md4

          public static final HashAlgorithm md4

    - #### ripemd128

          public static final HashAlgorithm ripemd128

    - #### ripemd160

          public static final HashAlgorithm ripemd160

    - #### whirlpool

          public static final HashAlgorithm whirlpool

    - #### sha224

          public static final HashAlgorithm sha224

    - #### ripemd256

          public static final HashAlgorithm ripemd256

  - ### Field Detail

    - #### jceId

          public final java.lang.String jceId

      the id used for initializing the JCE message digest

    - #### ecmaId

          public final int ecmaId

      the id used for the BIFF encryption info header

    - #### ecmaString

          public final java.lang.String ecmaString

      the id used for OOXML encryption info header

    - #### hashSize

          public final int hashSize

      the length of the digest byte array

    - #### jceHmacId

          public final java.lang.String jceHmacId

      the id used for the integrity algorithm in agile encryption

    - #### needsBouncyCastle

          public final boolean needsBouncyCastle

      is bouncycastle necessary for calculating the digest

    - #### rsaOid

          public final java.lang.String rsaOid

      ASN1 object identifier of the digest value in combination with the RSA cipher

  - ### Method Detail

    - #### values

          public static HashAlgorithm[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (HashAlgorithm c : HashAlgorithm.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static HashAlgorithm valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### fromEcmaId

          public static HashAlgorithm fromEcmaId(int ecmaId)

    - #### fromEcmaId

          public static HashAlgorithm fromEcmaId(java.lang.String ecmaString)

    - #### fromString

          public static HashAlgorithm fromString(java.lang.String string)

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.